VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cLvPag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
 Option Explicit

' Constantes que usa SendMessage
Private Const LVM_FIRST As Long = &H1000
Private Const LVM_SETCOLUMNWIDTH As Long = LVM_FIRST + 30

' Declaracin del Api SendMessage para hacer el AutoSize de las columnas
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" ( _
                ByVal hWnd As Long, _
                ByVal wMsg As Long, _
                ByVal wParam As Long, _
                lParam As Any) As Long

Private Const WM_SETREDRAW As Long = &HB&

Enum E_Ajustar_Encabezados
    NO_AJUSTAR = 0
    AJUSTAR_POR_ITEM = -1
    AJUSTAR_POR_COLUMNA = -2
End Enum

Public AutoSizeColumnHeader As E_Ajustar_Encabezados

'Propiedades
Public PaginaActual As Long
Public Total_Paginas As Long
Public Registros_Por_Pagina As Long
Public sql As String

'Enum para la navegacin y para refrescar los datos
Enum E_Navegacion
    PRIMER_PAGINA = 0
    ANTERIOR = 1
    SIGUIENTE = 2
    ULTIMA_PAGINA = 3
    REFRESCAR = 4
End Enum


'Variables locales ( para el Listview, para la _
 conexin ADO y para la accin de navegacin por las pginas )
Private m_ListView          As ListView
Private m_Accion            As E_Navegacion
Private m_Connection        As ADODB.Connection
Private mImageList          As ImageList
Private mImageFieldName     As String

'Evento que muestra el total de registros, la pgina actual _
 y el total de paginas del recordset ( por ejemplo en un control Label )
Public Event MoveComplet(ByVal PaginaActual As Long, ByVal TotalPaginas As Long, ByVal Total_Registros As Long)

'Sub que llena el ListView ( recibe como parmetro la conexin ADO)
'***************************************************************************
Private Sub Cargar_ListView()

On Error GoTo ErrSub

Dim Rst As New ADODB.Recordset
Dim Registros As Long
Dim Columna As Integer
Dim ret As Boolean
    
    ' Muestra un mensaje de Error por si no hay un ListView asignado
    If m_ListView Is Nothing Then
        
        MsgBox "No se especific ningn contol " & _
               "ListView para mostrar los datos. ", vbCritical
        Exit Sub
        
    End If
    
    ' Muestra un mensaje de Error por si no hay una conexin ADO establecida
    If m_Connection Is Nothing Then
        
        MsgBox "No se especific ninguna coneccion ADODB. " & _
               " Especificar una. ", vbCritical
        Exit Sub
    End If
    
    'Verifica que se especific el comando sQL
    If sql = vbNullString Then
        ' Si no se especific , Muestra el error y sale
        MsgBox "No se especific ninguna consulta SQL", vbCritical
        Exit Sub
    End If
    
    
    If PaginaActual = 0 Then
       PaginaActual = 1
    End If
    
    Total_Paginas = PaginaActual
    
    With m_ListView
        ' -- Desactiva el repintado del Listview para que cargue mas rpido
        If .Parent.Visible Then
            Call SendMessage(.Parent.hWnd, WM_SETREDRAW, 0&, 0&)
            ret = True
        End If
        ' -- Limpia el ListView
        .ListItems.Clear
        .ColumnHeaders.Clear
        Set .SmallIcons = Nothing
        
    End With
    
    ' --  Ac le indica al recordset la cantidad de registros que tendr cada pgina
    Rst.PageSize = Registros_Por_Pagina
    
    ' Llena el Recordset
    Call Rst.Open(sql, m_Connection, adOpenKeyset)
    
    ' Para que no de error
    If Total_Paginas <= Rst.PageCount Then
        Rst.AbsolutePage = Total_Paginas
    End If
    
    'Asigna el toal de pginas a la variable
    Total_Paginas = Rst.PageCount
    
    
    ' -- cargar imagenes
    If mImageNameField <> vbNullString Then
       If Not mImageList Is Nothing Then
          If Not mImageList Is Nothing Then
            mImageList.ListImages.Clear
          End If
          
          Do While Not Rst.EOF
             mImageList.ListImages.Add ,,loadpicture(mImagePath &"\" &  )
          Loop
       End If
    End If
    
    
    'REcorre el Recordset para crear los encabezados columnas
    For Columna = 0 To Rst.Fields.Count - 1
        If Not IsNull(Rst.Fields(Columna).Name) Then
            m_ListView.ColumnHeaders.Add , , Rst.Fields(Columna).Name
        End If
    Next
    
    
    
    
    'Recorre el Recordset para aadir los registros
    Do While Not Rst.EOF
    
        Registros = Registros + 1
        
        Dim Item As ListItem
        
        If Not (mImageList Is Nothing) And (mImageFieldName <> vbNullString) Then
            If m_ListView.SmallIcons Is Nothing Then
                Set m_ListView.SmallIcons = mImageList
            End If
            Set Item = m_ListView.ListItems.Add(, , Rst.Fields(0).Value, , Rst.Fields("[" & mImageFieldName & "]"))
        Else
            Set Item = m_ListView.ListItems.Add(, , Rst.Fields(0).Value)
        End If
        For Columna = 1 To Rst.Fields.Count - 1
            
            If Not IsNull(Rst.Fields(Columna).Value) Then
                Item.SubItems(Columna) = Rst.Fields(Columna).Value
            End If
    
        Next
        'Siguiente registro
        Rst.MoveNext
        'Si lleg al lmite de registros de la gina, sale del DO While
        If (Registros >= Registros_Por_Pagina) Or (Rst.EOF) Then
            Exit Do
        End If
    
    Loop
    
    ' Ejecuta el evento con los datos de informacin
    RaiseEvent MoveComplet(PaginaActual, Total_Paginas, Rst.RecordCount)
    
        Select Case AutoSizeColumnHeader
        
            Case -1
                'Ajusta la columna  teniendo en cuenta el Item mas largo
                Call Ajustar_Ancho_Columna(m_ListView, -1)
            Case -2
                'Ajusta la Columna teniendo en cuenta el _
                 caption de la columna mas largo
                Call Ajustar_Ancho_Columna(m_ListView, -2)
        End Select
        
    If ret = True Then
        'Activa el repintado del contenedor del Listview
        ret = SendMessage(m_ListView.Parent.hWnd, WM_SETREDRAW, 1&, 0&)
        'Refresca el ListView
        m_ListView.Refresh
        m_ListView.Parent.Refresh
    End If

    
    'Cierra y descarga
    On Error Resume Next
        Rst.Close
        Set Rst = Nothing
    On Error GoTo 0

Exit Sub

'Error
ErrSub:

MsgBox "Nmero de error: " & Err.Number & vbNewLine & _
       " Descripcin del error: " & Err.Description, vbCritical

End Sub


'********************************************
' Subrutinas y funciones
'********************************************


'--------------------------------------------------------------
'Ajusta los encabezados columna del Listview
'-----------------------------------------------------

Public Sub Ajustar_Ancho_Columna(El_ListView As ListView, ByVal Modo_De_Ajuste As Long)
   
   Dim La_Columna As Long
   
   With El_ListView
      'Recorre los encabezados
      For La_Columna = 1 To .ColumnHeaders.Count
         ' Aplica el Autoajuste ( -1 mediante el item, -2 mediante el caption de la columna)
         Call ListView_AutoSize(El_ListView, La_Columna, Modo_De_Ajuste)
      Next
   
   End With
End Sub

Private Sub ListView_AutoSize(El_ListView As ListView, ByVal La_Columna As Long, ByVal Modo_De_Ajuste As Long)

   With El_ListView
      
      'si no est el ListView en modo reporte sale
      If .View = lvwReport Then
         'Si hay columnas
         If La_Columna >= 1 And La_Columna <= .ColumnHeaders.Count Then
            'Establece el Autosize
            Call SendMessage(.hWnd, LVM_SETCOLUMNWIDTH, _
                             La_Columna - 1, ByVal Modo_De_Ajuste)
         End If
      End If
   End With
End Sub

'--------------------------------------------------------------
'Navegacin por las pginas
'--------------------------------------------------------------


'Navega a la primer pgina del recordset
Sub FirstPage()
    m_Accion = PRIMER_PAGINA
    
    Call Calcular_Pagina
End Sub

'Navega a la Anterior pgina del recordset
Sub PreviousPage()
    m_Accion = ANTERIOR
    
    Call Calcular_Pagina

End Sub

' Va a la Siguiente pgina del recordset
Sub NexPage()
    m_Accion = SIGUIENTE
    
    Call Calcular_Pagina

End Sub

' Va a la  ltima pgina del recordset
Sub LastPage()
    m_Accion = ULTIMA_PAGINA
    
    Call Calcular_Pagina

End Sub

'Refresca los datos del Listview ( Los vuelve a cargar )
Sub Refresh()
    m_Accion = REFRESCAR
    
    Call Calcular_Pagina
End Sub

' Navega al nmero de pagina indicado por el parmetro
Sub GoToPage(Pagina As Long)
    PaginaActual = Pagina 'Asigna la pgina
    Call Cargar_ListView 'Carga
End Sub


Private Sub Calcular_Pagina()
    
    ' Verifica la opcin de navegacin que se elig, para _
      establecer el valor de la variable --> PaginaActual
    
    Select Case m_Accion
    
        Case PRIMER_PAGINA
            PaginaActual = 1
        Case ANTERIOR
            If PaginaActual > 1 Then PaginaActual = PaginaActual - 1
        Case SIGUIENTE
            If PaginaActual < Total_Paginas Then PaginaActual = PaginaActual + 1
        Case ULTIMA_PAGINA
            PaginaActual = Total_Paginas
    End Select
    
        Call Cargar_ListView
    
End Sub



'********************************************
'Propiedades
'********************************************

' Para la Conexin ADO
Public Property Get Connection() As ADODB.Connection
    Connection = m_Connection
End Property

'Establece
Public Property Set Connection(Conexion_ADODB As ADODB.Connection)
    Set m_Connection = Conexion_ADODB
End Property

' Propiedad para el ListView
Public Property Get ListView() As ListView
    Set ListView = m_ListView
End Property
Public Property Set ListView(v_ListView As ListView)
    Set m_ListView = v_ListView
End Property

Public Property Let ListView(v_ListView As ListView)
    Set m_ListView = v_ListView
End Property

' Propiedad para el ImageList
Public Property Get ImageList() As ImageList
    Set ImageList = mImageList
End Property
Public Property Set ImageList(ImageList As ImageList)
    Set mImageList = ImageList
End Property

Public Property Let ImageList(ImageList As ImageList)
    Set mImageList = ImageList
End Property

Property Get ImageFieldName() As String
   ImageFieldName = mImageFieldName
End Property

Property Let ImageFieldName(ByVal sValue As String)
   mImageFieldName = sValue
End Property


' Descarga del mdulo de clase
Private Sub Class_Terminate()

    If Not m_ListView Is Nothing Then Set m_ListView = Nothing
    If Not mImageList Is Nothing Then Set mImageList = Nothing

    If Not m_Connection Is Nothing Then
        On Error Resume Next
        Set m_Connection = Nothing
        m_Connection.Close
        On Error GoTo 0
    End If
End Sub
